jQuery( document ).ready()
{
	jQuery( '.wp-list-table .type-instapage_post' ).each( function( index, value )
	{
		var element_id = jQuery( value ).attr( 'id' );
		var pattern = /post-(\d+)/g;
		var post_id_array = pattern.exec( element_id );
		var data = {};
		
		if( post_id_array[1] != 'undefined' )
		{
			data = {
				'action': 'instapage_check_stats',
				'instapage_post_id': post_id_array[1]
			};
			jQuery.post(
				INSTAPAGE.ajax_url, 
				data, 
				function( response )
				{
					response_obj = JSON.parse( response );
					stat_row = jQuery( '#' + element_id + '.type-instapage_post' );
					stat_row.find( '.stat-loader' ).addClass( 'loaded' );
					
					if( response_obj.status == 'ok' && response_obj.stats != null )
					{
						stat_row.find( '.instapage-index-page-stats' ).html( response_obj.message );
						stat_row.find( '.instapage_post_visits' ).html( response_obj.stats.visits );
						stat_row.find( '.instapage_post_conversions' ).html( response_obj.stats.conversions );
						stat_row.find( '.instapage_post_conversion_rate' ).html( response_obj.stats.conversion_rate + '%' );
					}
				}
			);
		}
	} );

	jQuery( '#instapage_meta_box select[name="post-type"]' ).ready( function()
	{
		var disableEnter = function( e )
		{
			if( e.keyCode == 13 )
			{
				e.preventDefault();
				e.stopPropagation();
				return false;
			}
		}

		if( jQuery( '#instapage_meta_box select[name="post-type"]' ).length )
		{
			jQuery( document ).keypress( function( e )
			{
				disableEnter( e );
			} );
			jQuery( '#instapage_slug' ).keypress( function( e )
			{
				disableEnter( e );
			} );
		}

	} );

	jQuery( 'a.instapage-hide-stats' ).ready( function()
	{
		jQuery( 'a.instapage-hide-stats' ).on( 'click', function( e )
		{
			e.preventDefault();

			if ( jQuery( 'td.column-instapage_post_stats .instapage-index-page-stats' ).is( ':visible' ) )
			{
				jQuery( this ).text( 'Show Stats' );
				jQuery( '.column-instapage_post_stats' ).width( '80px' );
			}
			else
			{
				jQuery( this ).text( 'Hide Stats' );
				jQuery( '.column-instapage_post_stats' ).width( '330px' );
			}

			jQuery( '.instapage-variation-stats-column-text' ).toggle();
			jQuery( 'td.column-instapage_post_stats .instapage-index-page-stats' ).toggle();
		});
	});

	jQuery( '#instapage_my_selected_page' ).ready( function()
	{
		var instapage_name = jQuery( '#instapage_my_selected_page' ).find( ':selected' ).text().trim();
		jQuery( '.instapage_name_text_field' ).text( instapage_name );
		jQuery( '#instapage_name' ).val( instapage_name );


		jQuery( '#instapage_my_selected_page' ).on( 'change', function()
		{
			instapage_name = jQuery( this ).find( ':selected' ).text().trim();
			jQuery( '.instapage_name_text_field' ).text( instapage_name );
			jQuery( '#instapage_name' ).val( instapage_name );
		});
	});

	jQuery( 'input#publish' ).ready( function()
	{
		jQuery( this ).click( function()
		{
			selected_value = jQuery( 'select[name="post-type"] option:selected' ).val();

			if( selected_value == '404' || selected_value == 'home' )
			{
				jQuery( '#instapage_slug' ).val( '' );
			}

			return true;
		} );
	} );

	jQuery( '#instapage_meta_box select[name="post-type"]' ).ready( function()
	{
		if ( jQuery( '#instapage_meta_box select[name="post-type"]' ).val() === 'home' || jQuery( '#instapage_meta_box select[name="post-type"]' ).val() === '404' )
		{
			jQuery( '.subsection_instapage_url' ).addClass( 'hidden' );
		}
		else
		{
			jQuery( '.subsection_instapage_url' ).removeClass( 'hidden' );
			resizeInstapageSlug();
		}

		jQuery( '#instapage_meta_box select[name="post-type"]' ).on( 'change', function()
		{
			if ( jQuery( this ).val() === 'home' || jQuery( this ).val() === '404' )
			{
				jQuery( '.subsection_instapage_url' ).addClass( 'hidden' );
			}
			else
			{
				jQuery( '.subsection_instapage_url' ).removeClass( 'hidden' );
				resizeInstapageSlug();
			}
		});
	});

	jQuery( '#instapage-wp-path' ).ready( function()
	{
		setTimeout( function()
		{

			var submit_valid = false;

			resizeInstapageSlug();

			var add_on_width = parseInt( jQuery( '#instapage-wp-path .add-on' ).outerWidth(), 10 ) + 6;
			var submit_valid = false;
			jQuery( '#instapage_slug' ).css( 'padding-left', add_on_width + 'px' );

			jQuery( '#publish' ).click( function( e )
			{
				if ( !submit_valid )
				{
					e.preventDefault();

					jQuery( '#instapage_slug' ).css( 'border', '0' );

					if ( ( jQuery( '#instapage_slug' ).val() === '' && jQuery( 'select[name="post-type"]' ).val() === '' ) )
					{
						if ( jQuery( '#instapage_slug' ).val() === '' && jQuery( 'select[name="post-type"]' ).val() === '' )
						{
							jQuery( '#instapage_slug' ).css( 'border', '1px solid red' );
						}
					}
					else
					{
						submit_valid = true;
						jQuery( this ).trigger( 'click' );
					}
				}
			});
		}, 500 );
	});

	function resizeInstapageSlug()
	{
		setTimeout( function()
		{
			var add_on_width = parseInt( jQuery( '#instapage-wp-path .add-on' ).outerWidth(), 10 ) + 6;
			jQuery( '#instapage_slug' ).css( 'padding-left', add_on_width + 'px' );
		}, 500 );
	}
}

function instapage_redirection( location )
{
	jQuery( 'body' ).html( '' );
	window.location = location;
}

function instapage_remove_edit()
{
	jQuery( '#poststuff' ).hide();
}
