<?php
/**
 * @package OuttaTimr
 * @version 1.4
 */
/*
Plugin Name: OuttaTimr
Plugin URI: http://outtatimr.com
Description: The Ultimate Email Countdown Timer
Author: DigitalMarketer 
Version: 1.4
*/


class EmailCounter{
	public static $name = "email_counter";
	public static $table_name = "wp_counters";
	public static $public;
	
	var $plugin_location;
	
	function EmailCounter(){
		$this->plugin_location = WP_PLUGIN_DIR .'/outtatimr';
		static::$public = $this->plugin_location ."/public";
		
				
		$this->load_files();
				
		if(isset($_GET['timr'])){
			$this->load_banner($_GET['timr']);
			die();
		}	
		
		if(isset($_GET['timr_link'])){
			Link::redirect();
			die();
		}
		
		
		$updater = new UpdateController(__FILE__);
		register_activation_hook( __FILE__, array( &$this, 'activate' ) );
		
					
		if ( is_admin() ) {
			global $wpdb;
			$update_check_sql = "SHOW COLUMNS FROM `".$wpdb->prefix."counters` LIKE 'timezone'";
		
			$update_check_result = $wpdb->query($update_check_sql);
			if(!$update_check_result){
				$update_sql = "ALTER TABLE `".$wpdb->prefix."counters` ADD COLUMN (timezone varchar(150))";	
				$wpdb->query($update_sql);							
			}
			
	        add_filter( "pre_set_site_transient_update_plugins", array( $updater, "set_transient" ) );
	        add_filter( "plugins_api", array( $updater, "set_plugin_info" ), 10, 3 );
			add_action('admin_menu', array(&$this, 'admin_menu'));
		}
	}
	
	static function init(){
		global $wpdb;
		static::$table_name = $wpdb->prefix ."counters";
	}

	function activate(){
		global $wpdb;
		$counters_sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."counters` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `end_time` time DEFAULT NULL,
  `end_date` date DEFAULT NULL,
  `name` varchar(225) DEFAULT NULL,
  `template` varchar(200) DEFAULT NULL,
  `expired` varchar(200) DEFAULT NULL,
  `width` int(11) DEFAULT NULL,  
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;";

		$links_sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."counters_links` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(225) DEFAULT NULL,
  `active_url` varchar(225) DEFAULT NULL,
  `inactive_url` varchar(225) DEFAULT NULL,
  `counter_id` int(11) DEFAULT NULL,
  `slug` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;";

		
		$wpdb->query($counters_sql);
		$wpdb->query($links_sql);		

	}
	
	function admin_menu(){
		add_menu_page('OuttaTimr', 'OuttaTimr', 'manage_options', 'email_counter.php', array(&$this, 'build_admin_page'), plugins_url('public/img/icon.png', __FILE__)); 
	}
	
	function load_wp(){
		define( 'SHORTINIT', true );
		require_once('../../../wp-load.php' );		
	}
	
	function load_files(){
		include("controllers/update_controller.php");
		include("models/expired.php");
		include("models/banner.php");
		include("models/application.php");
		include("models/counter.php");
		include("models/link.php");				
	}
	
	function build_admin_page(){
		
		include_once("controllers/admin_controller.php");
	}
	
	function load_banner($banner_id){

		$counter = Counter::find_first(intval($banner_id));
		$counter->display();
	}
	
}
EmailCounter::init();
$ec = new EmailCounter();
?>
